# ApplicationFramework
TKLCAF
TNaming

# TNaming_Selector Class Reference

This class provides a single API for selection of shapes.
This involves both identification and selection of
shapes in the data framework.
If the selected shape is modified, this selector will
solve its identifications.
This class is the user interface for topological
naming resources.
* The <isidentified> method returns (if exists)
the NamedShape which contains a given shape. The
definition of an identified shape is : a Shape
handled by a NamedShape (this shape is the only
one stored) , which has the TNaming_PRImITIVE evolution
* The <select> method returns ALWAYS a new
NamedShape at the given label, which contains the
argument selected shape. When calling this
method, the sub-hierarchy of <label> is first cleared,
then a TNaming_NamedShape is ALWAYS created at
this <label>, with the TNaming_SELECTED evolution.
The <naming attribute=""> is associated to the selected
shape which store the arguments of the selection .
If the given selected shape was already identified
(method IsIdentified) , this Naming attribute
contains the reference (Identity code) to the
argument shape.
.

`#include <TNaming_Selector.hxx>`

## Public Member Functions

void * | operator new (size_t, void *anAddress)
void * | operator new (size_t size)
void | operator delete (void *anAddress)
Standard_EXPORT | TNaming_Selector (const TDF_Label &aLabel)
| Create a selector on this label //! to select a shape. ================== .
Standard_EXPORT Standard_Boolean | Select (const TopoDS_Shape &Selection, const TopoDS_Shape &Context, const Standard_Boolean Geometry=Standard_False) const
| Creates a topological naming on the label aLabel given as an argument at construction time. If successful, the shape Selection - found in the shape Context - is now identified in the named shape returned in NamedShape. If Geometry is true, NamedShape contains the first appearance of Selection. This syntax is more robust than the previous syntax for this method. .
Standard_EXPORT Standard_Boolean | Select (const TopoDS_Shape &Selection, const Standard_Boolean Geometry=Standard_False) const
| Creates a topological naming on the label aLabel given as an argument at construction time. If successful, the shape Selection is now identified in the named shape returned in NamedShape. If Geometry is true, NamedShape contains the first appearance of Selection. .
Standard_EXPORT Standard_Boolean | Solve (TDF_LabelMap &Valid) const
| Updates the topological naming on the label aLabel given as an argument at construction time. The underlying shape returned in the method NamedShape is updated. To read this shape, use the method TNaming_Tool::GetShape .
Standard_EXPORT void | Arguments (TDF_AttributeMap &args) const
| Returns the attribute list args. This list contains the named shape on which the topological naming was built. .
Standard_EXPORT Handle_TNaming_NamedShape | NamedShape () const
| Returns the NamedShape build or under construction, which contains the topological naming.. .

## Static Public Member Functions

static Standard_EXPORT Standard_Boolean | IsIdentified (const TDF_Label &access, const TopoDS_Shape &selection, Handle(TNaming_NamedShape)&NS, const Standard_Boolean Geometry=Standard_False)

To know if a shape is already identified (not selected)
=======================================================
The label access defines the point of access to the data framework.
selection is the shape for which we want to know
whether it is identified or not.
If true, NS is returned as the identity of selection.
If Geometry is true, NS will be the named shape
containing the first appearance of selection and
not any other shape. In other words, selection
must be the only shape stored in NS.
.

## Private Attributes

TDF_Label | myLabel

## Constructor & Destructor Documentation

Standard_EXPORT TNaming_Selector::TNaming_Selector | ( | const TDF_Label & | aLabel | ) |

## Member Function Documentation

Standard_EXPORT void TNaming_Selector::Arguments | ( | TDF_AttributeMap & | args | ) | const

static Standard_EXPORT Standard_Boolean TNaming_Selector::IsIdentified | ( | const TDF_Label & | access,
|  | const TopoDS_Shape & | selection,
|  | Handle(TNaming_NamedShape)& | NS,
|  | const Standard_Boolean | Geometry = `Standard_False`
| ) | `[static]`

Standard_EXPORT Handle_TNaming_NamedShape TNaming_Selector::NamedShape | ( |  | ) | const

void TNaming_Selector::operator delete | ( | void * | anAddress | ) | `[inline]`

void* TNaming_Selector::operator new | ( | size_t | size | ) | `[inline]`

void* TNaming_Selector::operator new | ( | size_t | ,
|  | void * | anAddress
| ) | `[inline]`

Standard_EXPORT Standard_Boolean TNaming_Selector::Select | ( | const TopoDS_Shape & | Selection,
|  | const Standard_Boolean | Geometry = `Standard_False`
| ) | const

Standard_EXPORT Standard_Boolean TNaming_Selector::Select | ( | const TopoDS_Shape & | Selection,
|  | const TopoDS_Shape & | Context,
|  | const Standard_Boolean | Geometry = `Standard_False`
| ) | const

Standard_EXPORT Standard_Boolean TNaming_Selector::Solve | ( | TDF_LabelMap & | Valid | ) | const

## Field Documentation

TDF_Label TNaming_Selector::myLabel `[private]`

The documentation for this class was generated from the following file:

- TNaming_Selector.hxx